using System;
using System.Text;

namespace DevTips.Tips;

class stringEncodingClient
{
    public static void Client()
    {
        System.Console.WriteLine("string to char[]");
        string str = "Hello 한국 People";
        char[] uchars = str.ToCharArray();
        PrintCharArr(uchars);

        System.Console.WriteLine("uicode");
        byte[] ubytes = Encoding.Unicode.GetBytes(str);
        PrintByteArr(ubytes);
        System.Console.WriteLine(Encoding.Unicode.GetString(ubytes));

        System.Console.WriteLine("UTF8");
        byte[] utf8bytes = Encoding.UTF8.GetBytes(str);
        PrintByteArr(utf8bytes);
        System.Console.WriteLine(Encoding.UTF8.GetString(utf8bytes));

        byte[] asciiBytes = Encoding.ASCII.GetBytes(":25DPS??12\r\n");
        PrintByteArr(asciiBytes);
        System.Console.WriteLine(Encoding.ASCII.GetString(asciiBytes));

        byte lrc = 0x12;
        string strLrc = lrc.ToString("X2");
        System.Console.WriteLine(strLrc.Length);
        System.Console.WriteLine(strLrc[0]);
        System.Console.WriteLine(strLrc[1]);
    }

    private static void PrintCharArr(char[] chars)
    {
        foreach (var elem in chars)
        {
            System.Console.Write(elem + " ");
        }
        System.Console.WriteLine();
    }

    private static void PrintByteArr(byte[] bytes)
    {
        foreach (var elem in bytes)
        {
            System.Console.Write(elem.ToString("X2") + " ");
        }
        System.Console.WriteLine();
    }
}