using System;

namespace DevTips.Tips
{
    class FuncClient
    {
        private static int _state;

        public static void Client()
        {
            // Default
            Func<bool> func1 = IsValid;
            System.Console.WriteLine(func1());

            // Ananymous method
            Func<bool> func2 = delegate
            {
                return _state == 0;
            };
            System.Console.WriteLine(func2());


            // Lambda
            Func<bool> func3 = () => _state == 0;
            System.Console.WriteLine(func3());

        }

        private static bool IsValid()
        {
            return _state == 0;
        }
    }
}